searchNodes=[{"doc":"EctoTemp is use 'd to set up a module for managing temp tables. Once set up, macros such as EctoTemp.Macros.deftemptable/3 , EctoTemp.Macros.column/3 , and macros in EctoTemp.Factory may be used. Examples defmodule MyTest do use MyProject.DataCase use EctoTemp , repo : MyProject.Repo require EctoTemp.Factory alias EctoTemp.Factory deftemptable :things do column :data , :string , null : false column :data_with_default , :string , default : &quot;default value&quot; deftimestamps ( ) end deftemptable :other_things , primary_key : false do column :id , :uuid , null : false column :data , :string , null : false column :data_with_default , :string , default : &quot;default value&quot; deftimestamps ( ) end setup do create_temp_tables ( ) :ok end test &quot;insert records&quot; do Factory . insert ( :things , data : &quot;stuff&quot; ) end end","ref":"EctoTemp.html","title":"EctoTemp","type":"module"},{"doc":"Imports EctoTemp into a module. Options :repo - required - the module defining your Ecto.Repo callbacks. Example defmodule MyModule do use EctoTemp , repo : MyProject.Repo end","ref":"EctoTemp.html#__using__/1","title":"EctoTemp.__using__/1","type":"macro"},{"doc":"","ref":"EctoTemp.Factory.html","title":"EctoTemp.Factory","type":"module"},{"doc":"Inserts values into a temporary table. Params: struct (optional) - a struct defined the schema used by the data migration. table_name attrs (optional) - a keyword list of attributes to insert Notes: If not given a struct, and the temporary table has a primary key, then we return the id of the inserted row. If given a struct, and the temporary table has a primary key, then we do a Repo.get using the id of the inserted row, and return the result as a struct. If the temporary table has no primary key, then we return the list of values returned by postgres. This list is probably ordered by the order in which the columns are defined on the temp table??? Examples import EctoTemp.Factory insert ( :thing_with_no_primary_key ) == [ ] insert ( :thing_with_no_primary_key , some_thing : &quot;hi&quot; ) == [ &quot;hi&quot; ] insert ( :thing_with_primary_key ) == 1 insert ( :thing_with_primary_key , some_thing : &quot;hi&quot; ) == 2 % MyDataMigration.Cycle { id : 1 } = insert ( MyDataMigration.Cycle , :cycles , started_at : ~N[2020-02-03 00:00:00] )","ref":"EctoTemp.Factory.html#insert/3","title":"EctoTemp.Factory.insert/3","type":"macro"},{"doc":"","ref":"EctoTemp.Macros.html","title":"EctoTemp.Macros","type":"module"},{"doc":"Add a column to a table definition. This must be called within a deftemptable block, or a CompileError will be raised.","ref":"EctoTemp.Macros.html#column/3","title":"EctoTemp.Macros.column/3","type":"macro"},{"doc":"Runs through previously defined @ecto_temporary_tables to insert temporary tables. This should be called in a setup block, which needs to be defined after all deftemptable definitions.","ref":"EctoTemp.Macros.html#create_temp_tables/0","title":"EctoTemp.Macros.create_temp_tables/0","type":"macro"},{"doc":"Creates a temporary table that will be rolled back at the end of the current test transaction. If the table name is given as :thing , then the actual temporary table will be created as thing_temp . Examples deftemptable :cycles do column :athlete_plan_id , :integer , null : false deftimestamps ( ) end deftemptable :scan , primary_key : false do column :scan_sha , :string , null : false column :comment , :string end Opts name type default description primary_key boolean true When true, adds an :id field of type :bigserial","ref":"EctoTemp.Macros.html#deftemptable/3","title":"EctoTemp.Macros.deftemptable/3","type":"macro"},{"doc":"Adds inserted_at and updated_at to a table definition. This must be called within a deftemptable block, or a CompileError will be raised.","ref":"EctoTemp.Macros.html#deftimestamps/0","title":"EctoTemp.Macros.deftimestamps/0","type":"macro"},{"doc":"EctoTemp provides macros and helper functions for creating and utilizing temporary tables in Postgres. Among other use cases, this library can be utilized to test data migrations (where the underying table may change over time) or ecto type extensions in isolation, where no one persistent table exist. The temporary tables created by this library are transaction local, using ON COMMIT DROP . The PostgreSQL documentation on creating tables describes this setting as follows: The temporary table will be dropped at the end of the current transaction block. When used on a partitioned table, this action drops its partitions and when used on tables with inheritance children, it drops the dependent children. For use in ExUnit , this means that any temporary tables created in the context of the Ecto.Adapters.SQL.Sandbox are scoped to the test's database connection, and are deleted at the end of each test.","ref":"overview.html","title":"EctoTemp","type":"extras"},{"doc":"After adding :ecto_temp to a project's Mix dependencies, a test can use EctoTemp, repo: &lt;My.Repo&gt; . Temporary tables are defined with EctoTemp.Macros.deftemptable/3 and EctoTemp.Macros.column/2 . Temp tables are actually created in the database with EctoTemp.Macros.create_temp_tables/0 . defmodule MyTest do use Test.DataCase , async : true use EctoTemp , repo : MyProject.Repo deftemptable :things do column :data , :string , null : false column :data_with_default , :string , default : &quot;default value&quot; deftimestamps ( ) end setup do create_temp_tables ( ) :ok end end In tests, EctoTemp.Factory.insert/3 can be used to insert data into a temporary table. As a macro, it must be used via import or require . defmodule MyTest do # ... require EctoTemp.Factory test &quot;inserts data into a temp table&quot; do Factory . insert ( :things , data : &quot;stuff&quot; ) end end An example of a real project using EctoTemp to test an Ecto.Type extensions can be found in the ecto_date_time_range project.","ref":"overview.html#usage","title":"EctoTemp - Usage","type":"extras"},{"doc":"Database data migrations face at least two primary problems with regard to testing: database schemas will change in the future; application modules will change in the future. Tests that rely on either face a high likelihood of failing. Ecto provides a mechanism for overriding the database table used by a query, via Ecto.put_meta/2 with the :source attribute, or via {table, Schema} when making queries.","ref":"data_migrations.html","title":"Data Migrations","type":"extras"},{"doc":"Imagine a data migration that takes a bunch of things, modifies one or more fields, and creates other related things. This data migration can define its own schema modules, representing the schema at the time of migration. At any place a database interaction occurs, the table name for each entity must be specified. To ensure that this is the case, the schemas define their tables as replace_me_at_runtime , so that code that forgets to override it will blow up. defmodule Core.DataMigrations.MyMigration do import Ecto.Query defmodule Thing do use Ecto.Schema import Ecto.Changeset schema &quot;replace_me_at_runtime&quot; do field :data , :string timestamps ( ) end @doc &quot;&quot;&quot; Note that when constructing a query, `{table_name, Thing}` is used in place of `Thing`. This overrides the database table used by the query. &quot;&quot;&quot; def all ( table_name ) , do : from ( things in { table_name , Thing } ) @doc &quot;&quot;&quot; When modifying data, `Ecto.put_meta/2` is utilized to enfore the table name. &quot;&quot;&quot; def update_changeset ( thing , table_name ) do thing |&gt; Ecto . put_meta ( source : table_name ) |&gt; change ( data : thing . data &lt;&gt; &quot;-ish&quot; ) end end defmodule OtherThing do use Ecto.Schema import Ecto.Changeset schema &quot;replace_me_at_runtime&quot; do field :thing_id , :bigint timestamps ( ) end def insert_changeset ( thing , table_name ) do % OtherThing { } |&gt; Ecto . put_meta ( source : table_name ) |&gt; change ( thing_id : thing . id ) end end @doc &quot;&quot;&quot; Table names are injected by the tests, but default to the real tables used by the application. &quot;&quot;&quot; def run ( things_table \\\\ &quot;things&quot; , other_things_table \\\\ &quot;other_things&quot; ) do Core.Repo . transaction ( fn -&gt; Thing . all ( things_table ) |&gt; Repo . stream ( ) |&gt; Stream . map ( &amp; Thing . update_changeset ( &amp;1 , things_table ) ) |&gt; Stream . map ( &amp; update_thing / 1 ) |&gt; Stream . map ( &amp; OtherThing . insert_changset ( &amp;1 , other_things_table ) ) |&gt; Stream . map ( &amp; insert_other_thing / 1 ) end , timeout : 60_000 ) end def update_thing ( thing_changeset ) , do : thing_changeset |&gt; Core.Repo . update! ( ) def insert_other_thing ( other_thing_changeset ) , do : other_thing_changeset |&gt; Core.Repo . insert! ( ) end","ref":"data_migrations.html#example-data-migration","title":"Data Migrations - Example Data Migration","type":"extras"},{"doc":"The test can rely on the schemas defined by the migration, and inject temporary tables at runtime: defmodule Core.DataMigrations.MyMigrationTest do use Test.DataCase , async : true use EctoTemp , repo : Core.Repo alias Core.DataMigrations.MyMigration , as : Migration require EctoTemp.Factory deftemptable :temp_things do column :data , :string , null : false deftimestamps ( ) end deftemptable :temp_other_things do column :thing_id , :integer , null : false deftimestamps ( ) end setup do create_temp_tables ( ) :ok end describe &quot;run&quot; do test &quot;does stuff&quot; do Factory . insert ( :temp_things , data : &quot;stuff&quot; ) assert { &quot;temp_other_things&quot; , Migration.OtherThing } |&gt; Core.Repo . all ( ) == [ ] # inject tables Migration . run ( &quot;temp_things&quot; , &quot;temp_other_things&quot; ) [ thing ] = { &quot;temp_things&quot; , Migration.Thing } |&gt; Core.Repo . all ( ) assert thing . data == &quot;stuff-ish&quot; assert [ other_thing ] = { &quot;temp_other_things&quot; , Migration.OtherThing } |&gt; Core.Repo . all ( ) assert other_thing . thing_id == thing . id end end end","ref":"data_migrations.html#example-test","title":"Data Migrations - Example Test","type":"extras"},{"doc":"","ref":"changelog.html","title":"Change Log","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Change Log - Unreleased","type":"extras"},{"doc":"Add :primary_key info to documentation.","ref":"changelog.html#0-1-3","title":"Change Log - 0.1.3","type":"extras"},{"doc":"Add overview, data migrations to documentation.","ref":"changelog.html#0-1-2","title":"Change Log - 0.1.2","type":"extras"},{"doc":":ecto and :ecto_sql are required in any environment that uses :ecto_temp . Use Apache 2.0 license. Updated project URL.","ref":"changelog.html#0-1-1","title":"Change Log - 0.1.1","type":"extras"},{"doc":"Initial release.","ref":"changelog.html#0-1-0","title":"Change Log - 0.1.0","type":"extras"},{"doc":"Copyright 2022 synchronal.dev Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"}]